import Vue from 'vue'
import Dialog from '../nav/dialog'
import Sheet from '../nav/sheet'
import Snackbar from '../nav/snackbar'

export default class {
  static dialog(properties) {
    // https://css-tricks.com/creating-vue-js-component-instances-programmatically/
    const DialogClass = Vue.extend(Dialog)
    const instance = new DialogClass()
    instance.spec = properties

    const placeholder = document.body.appendChild(document.createElement('div'))
    instance.$mount(placeholder)

    // TODO: doesn't work when this method gets called the second time
    // TODO: need to maintain a stack instead
    // this.dialog = instance
  }

  static closeDialog(properties, target, component) {
    Utils.type.ifObject(this.dialog, dialog => {
      dialog.close()
    })
    this.dialog = null

    Utils.type.ifObject(properties['onClose'], it => {
      Action.execute(it, target, component)
    })
  }

  static sheet(properties) {
    const SheetClass = Vue.extend(Sheet)
    const instance = new SheetClass()
    instance.spec = properties
    const placeholder = document.body.appendChild(document.createElement('div'))
    instance.$mount(placeholder)
    instance.show = true
  }

  static snackbar(properties) {
    const SnackbarClass = Vue.extend(Snackbar)
    const instance = new SnackbarClass()
    instance.spec = properties

    const placeholder = document.body.appendChild(document.createElement('div'))
    instance.$mount(placeholder)
    instance.show = true
  }
}
